local LrPathUtils=import"LrPathUtils"local LrFtp=import"LrFtp"local LrFileUtils=import"LrFileUtils"local LrErrors=import"LrErrors"local LrDialogs=import"LrDialogs"local LrLogger=import"LrLogger"local LrHttp=import"LrHttp"local LrMD5=import"LrMD5"local LrApplication=import"LrApplication"local LrTasks=import"LrTasks"local LrStringUtils=import"LrStringUtils"require"Info"require"FileLRDialogues"function deleteLogFile()local logPath=LrPathUtils.child(LrPathUtils.getStandardFilePath("documents"),"GFLR.log")if LrFileUtils.exists(logPath)then local success,reason=LrFileUtils.delete(logPath)if not success then logger:error("Error deleting existing logfile!"..reason)end end end function loglog(value,level)if(logger==nil)then logger=LrLogger("GFLR")logger:enable("logfile")end if type(value)=="table"then logger:infof("%d: value is table",level);for k,v in pairs(value)do logger:infof("%d: key is  %s",level+1,k)loglog(v,level+1);end else logger:infof("%d: value = %s",level,value);end end function log(debug,value)if debug then loglog(value,0);end end function valueNoGood(value)if value==nil or value==""then return true end return false end function valueWithDefault(value,default)if valueNoGood(value)then return default end return value end function twoValuesWithDefault(value1,value2,default)if valueNoGood(value1)and valueNoGood(value2)then return default end if valueNoGood(value1)then return value2 end return value1 end function getError(result,hdrs)if hdrs.error~=nil then return hdrs.error.name end if hdrs.status~=200 then if result==nil or result==""then return"Server response ("..hdrs.status.."): "..hdrs.statusDes else return"Server response ("..hdrs.status.."): "..result end end return nil;end function print(file,data)file:write(data)end function println(file,data)file:write(data)file:write("\n")end function printPair(file,key,value)file:write(key)file:write("=")file:write(value)file:write("\n")end function Strip_Control_and_Extended_Codes(str)local s=""for i=1,str:len()do if str:byte(i)>=32 and str:byte(i)<=126 then s=s..str:sub(i,i)else s=s.."?"end end return s end function addHeader(photo,file,key,name1,name2,debug)local v=photo:getFormattedMetadata(name1)if valueNoGood(v)and name2~=nil then v=photo:getFormattedMetadata(name2)end if not valueNoGood(v)then printPair(file,"64."..key,LrStringUtils.encodeBase64(v))end end function processRenderedPhotos(functionContext,exportContext)local exportSession=exportContext.exportSession local exportParams=exportContext.propertyTable deleteLogFile()local galleryFile=LrPathUtils.child(exportParams.homeDirectory,exportParams.fileName..".glr")if LrFileUtils.exists(galleryFile)then local result=LrDialogs.confirm("Gallery File Already Exists",galleryFile,"Delete and Continue","Cancel")if result~="ok"then return end end local file=io.open(galleryFile,"wb")if file==nil then LrDialogs.message("Unable To Open Gallery File",galleryFile,"critical")return end log(exportParams.debug," ************** session ************** ")log(exportParams.debug,_PLUGIN.id)log(exportParams.debug,version())local nPhotos=exportSession:countRenditions()log(exportParams.debug,nPhotos.." images")printPair(file,"64.gallery-name",LrStringUtils.encodeBase64(exportParams.galleryName))printPair(file,"image-count",nPhotos)printPair(file,"plugin-version",version())printPair(file,"plugin-type","3")println(file,"****")local progressScope=exportContext:configureProgress{title=nPhotos>1 and LOC("$$$/FtpUpload/Upload/Progress=Uploading ^1 photos to iPad",nPhotos)or LOC"$$$/FtpUpload/Upload/Progress/One=Uploading one photo to iPad",}local failures={}for index,rendition in exportContext:renditions{stopIfCanceled=true}do log(exportParams.debug,"------------------------------- image "..index.." -------------------------------")local success,pathOrMessage=rendition:waitForRender()if success then log(exportParams.debug," Successful rendition: "..pathOrMessage)else log(exportParams.debug," Unsuccessful rendition: "..pathOrMessage)end if progressScope:isCanceled()then break end if success then local filename=LrPathUtils.leafName(pathOrMessage)local extension=LrPathUtils.extension(pathOrMessage)local parent=LrPathUtils.parent(pathOrMessage)log(exportParams.debug,"Filename: "..filename)log(exportParams.debug,"Extension: "..extension)local fileAttr=LrFileUtils.fileAttributes(pathOrMessage)log(exportParams.debug,fileAttr)local photo=rendition.photo log(exportParams.debug,"Photo size: "..photo:getFormattedMetadata("fileSize"))log(exportParams.debug,"Photo type: "..photo:getFormattedMetadata("fileType"))log(exportParams.debug,"Photo dimensions: "..photo:getFormattedMetadata("dimensions"))local rawPhotoData=LrFileUtils.readFile(pathOrMessage)printPair(file,"image",index)printPair(file,"Content-Length",string.len(rawPhotoData))printPair(file,"Content-Type","image/jpeg")addHeader(photo,file,"copyright","copyright","creator",exportParams.debug)addHeader(photo,file,"title","title","headline",exportParams.debug)addHeader(photo,file,"caption","caption",nil,exportParams.debug)addHeader(photo,file,"creator","creator",nil,exportParams.debug)addHeader(photo,file,"city","creatorCity","city",exportParams.debug)addHeader(photo,file,"country","creatorCountry","country",exportParams.debug)addHeader(photo,file,"state","creatorStateProvince","stateProvince",exportParams.debug)addHeader(photo,file,"date","dateCreated","dateTimeOriginal",exportParams.debug)println(file,"****")print(file,rawPhotoData)println(file,"****")file:flush()local headers={{field="plugin-version",value=version()},{field="plugin-type",value="2"},{field="image",value=index},{field="Content-Length",value=string.len(rawPhotoData)},{field="copyright",value=twoValuesWithDefault(photo:getFormattedMetadata("copyright"),photo:getFormattedMetadata("creator"),"2012-2013")},{field="Content-Type",value="image/jpeg"},}end end if#failures>0 then local message if#failures==1 then message=LOC"$$$/FtpUpload/Upload/Errors/OneFileFailed=1 file failed to upload correctly."else message=LOC("$$$/FtpUpload/Upload/Errors/SomeFileFailed=^1 files failed to upload correctly.",#failures)end LrDialogs.message(message,table.concat(failures,"\n"))end file:close()end return{showSections={"outputSharpening","watermarking","imageSettings","fileSettings"},hidePrintResolution=true;allowFileFormats=nil,allowColorSpaces=nil,exportPresetFields={{key="homeDirectory",default=LrPathUtils.getStandardFilePath("documents")},{key="galleryName",default="Exported from Lightroom"},{key="fileName",default="gallery"},{key="quality",default=100},{key="debug",default=true},},startDialog=FileLRDialogues.startDialog,sectionsForTopOfDialog=FileLRDialogues.sectionsForBottomOfDialog,processRenderedPhotos=processRenderedPhotos,}